
#pragma once

#include <ostream>
#include <istream>

using namespace std;

class V3 {
public:
	float xyz[3];
	V3() {};
	V3(float x, float y, float z);
	float& operator[](int i);
	V3 operator+(V3 op1);
	V3 operator-(V3 op1);
	float operator*(V3 op1);
	V3 operator*(float scf);
	V3 operator/(float scf);
	V3 operator^(V3 op1);
	friend ostream& operator<<(ostream& ostr, V3 v);
	unsigned int GetColor();
	void SetColor(unsigned int color);
	V3 RotateThisPointAboutAxis(V3 aO, V3 aD, float theta);
	V3 RotateThisVectorAboutAxis(V3 aD, float theta);
	float Length();
	V3 UnitVector();
	V3 Light(V3 n, V3 l, float ka); // directional light; this is material color
	V3 Light(V3 P, V3 n, V3 L, float ka);
	V3 EdgeEquation(V3 p0, V3 p1, V3 p2);
};

class AABB {
public:
	V3 corners[2];
	AABB(V3 firstPoint);
	void AddPoint(V3 newPoint);
	int ClipWithImageFrame(int w, int h);
};